//
// CIMInstanceException.java
//
// The contents of this file are subject to the SNIA Public License Version 1.0
// (the "License"); you may not use this file except in compliance with the
// License. You may obtain a copy of the License at
//
//	http://www.snia.org/resources/openSource.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
// License for the specific language governing rights and limitations
// under the License.
//
// The Original Code is CIMInstanceException.java
// 
// The Initial Developer of the Original Code is David Simons.
//
// Contributor(s): Peter Rivera
//
//
// This source uses the Solaris WBEM APIs version 2.2. 
// Synchronization will be maintained with the Solaris WBEM APIS,
// which are being standardized through the Java Community Process.
//
//
// $Id: CIMInstanceException.java,v 1.1 2003/07/17 18:32:55 kumpf Exp $
//
// $Log: CIMInstanceException.java,v $
// Revision 1.1  2003/07/17 18:32:55  kumpf
// HP-BAPU: PEP-64 CIM Client and CIM Listener Java Interface
//
// Revision 1.1.1.1  2001/10/31 18:14:23  karl
// import of SNIA 0_7
//
// Revision 1.6  2001/01/02 19:33:55  davidsi
// - Fixed propagation of arguments when 3 objects are passed.
//
// Revision 1.5  2000/08/16 05:59:52  shawn
// merge P_TOMCAT31 branch
//
// Revision 1.4.8.1  2000/08/10 00:03:27  shawn
// head merge
//
// Revision 1.4  2000/05/11 10:12:19  davidsi
// - Fixed tabs.
//
// Revision 1.3  2000/05/06 17:04:21  davidsi
// - Modifications to bring classes inline with the SUN WBEM APIs 2.2.
//
// Revision 1.2  2000/02/13 15:09:07  davidsi
// - Added text to cover re-use of Solaris WBEM APIs.
//
// Revision 1.1.1.1  2000/02/06 16:41:04  davidsi
// Initial version.
//
//
//
package org.snia.wbem.cim;

import org.snia.wbemcmd.xml.XMLError;

/**
    Exception class representing exceptions that occur in a CIM instance.
 */

public class CIMInstanceException  extends CIMSemanticException {

    //
    // NOT SUN
    //
    public static final String CIM_ERR_MISSING_KEY="CIM_ERR_MISSING_KEY";
    public static final String CIM_ERR_KEY_CANNOT_MODIFY="CIM_ERR_KEY_CANNOT_MODIFY";
    public static final String CIM_ERR_NO_KEYS="CIM_ERR_NO_KEYS";	// An instance without keys was specified
    public static final String CIM_ERR_KEYS_NOT_UNIQUE="CIM_ERR_KEYS_NOT_UNIQUE";// keys are not unique

    static {
	addErrorMap(CIM_ERR_MISSING_KEY,XMLError.XML_ERR_INVALID_PARAMETER);
	addErrorMap(CIM_ERR_KEY_CANNOT_MODIFY,XMLError.XML_ERR_INVALID_PARAMETER);
	addErrorMap(CIM_ERR_NO_KEYS,XMLError.XML_ERR_INVALID_PARAMETER);
	addErrorMap(CIM_ERR_KEYS_NOT_UNIQUE,XMLError.XML_ERR_INVALID_PARAMETER);
    }
    //
    // END NOT SUN
    //
    
	
    public CIMInstanceException() {
	super(CIMException.CIM_ERR_NOT_SUPPORTED);
    }


    public CIMInstanceException(String str) {
	super(str);
    }
    
    public CIMInstanceException(String str, Object obj) {
	super(str,obj);
    }
    
    public CIMInstanceException(String str, Object obj1, Object obj2) {
	super(str,obj1,obj2);
    }
    
    public CIMInstanceException(String str, Object obj1, Object obj2,Object obj3) {
	super(str,obj1,obj2,obj3);
    }
    
    public CIMInstanceException(String str, Object[] obj1) {
	super(str,obj1);
    }

}
