//
// CIMListener.java
//
// The contents of this file are subject to the SNIA Public License Version 1.0
// (the "License"); you may not use this file except in compliance with the
// License. You may obtain a copy of the License at
//
//      http://www.snia.org/resources/openSource.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
// License for the specific language governing rights and limitations
// under the License.
//
// The Original Code is CIMListener.java
//
// The Initial Developer of the Original Code is Adrian Schuur.
//
// Contributor(s):
//
//
// This source uses the Solaris WBEM APIs version 2.2.
// Synchronization will be maintained with the Solaris WBEM APIS,
// which are being standardized through the Java Community Process.
//
//
// $Id: CIMListener.java,v 1.1 2003/07/17 18:32:55 kumpf Exp $
//
// $Log: CIMListener.java,v $
// Revision 1.1  2003/07/17 18:32:55  kumpf
// HP-BAPU: PEP-64 CIM Client and CIM Listener Java Interface
//
// Revision 1.1.1.1  2001/10/31 18:14:46  karl
// import of SNIA 0_7
//
// Revision 1.1  2001/07/22 19:56:33  davidsi
// - From Adrian Schuur. Initial version.
//
// For HP Release 2.0 2003/03/12 ( Bapu Patil) 
// Support Indication and seperate CIMListner part from
// Client API code
//

package org.snia.wbem.listener;

import java.util.EventListener;

/**
  CIMListener interface for listening CIM/XML indication 
  events. All CIM Listener interfaces(such CIM/XML, RMI, 
  or Local) must extend this.
 
   @ see java.util.EventListener
 */ 
public interface CIMListener extends EventListener
{
   /**
    * indicationOccured method is called when the indication
    * received by the CIMListener.
    *
    * @param CIMIndication - is a CIM Instance Object
    *
    * @param URL - URL name of the indication request.
    *
    * @throws CIMException - none.
    */
    public void indicationOccured(CIMIndication e, String URL);
};
