//
// MOFLexerException.java
//
// The contents of this file are subject to the SNIA Public License Version 1.0
// (the "License"); you may not use this file except in compliance with the
// License. You may obtain a copy of the License at
//
//	http://www.snia.org/resources/openSource.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
// License for the specific language governing rights and limitations
// under the License.
//
// The Original Code is MOFLexerException.java
// 
// The Initial Developer of the Original Code is David Simons.
//
// Contributor(s):
//
//
// This source uses the Solaris WBEM APIs version 2.2. 
// Synchronization will be maintained with the Solaris WBEM APIS,
// which are being standardized through the Java Community Process.
//
//
// $Id: MOFLexerException.java,v 1.1 2003/07/17 18:32:55 kumpf Exp $
//
// $Log: MOFLexerException.java,v $
// Revision 1.1  2003/07/17 18:32:55  kumpf
// HP-BAPU: PEP-64 CIM Client and CIM Listener Java Interface
//
// Revision 1.1.1.1  2001/10/31 18:16:18  karl
// import of SNIA 0_7
//
// Revision 1.6  2000/08/16 05:59:58  shawn
// merge P_TOMCAT31 branch
//
// Revision 1.5.8.1  2000/08/10 00:03:33  shawn
// head merge
//
// Revision 1.5  2000/05/11 10:11:35  davidsi
// - Fixed tabs.
//
// Revision 1.4  2000/05/06 17:12:10  davidsi
// - Brought in line with SUN WBEM APIs 2.2
//
// Revision 1.3  2000/04/09 14:15:33  davidsi
// - Added exceptions for eof and no such token.
// - Cleaned up string representation to remove "=".
//
// Revision 1.2  2000/02/13 15:09:54  davidsi
// - Added text to cover re-use of Solaris WBEM APIs.
//
// Revision 1.1.1.1  2000/02/06 16:41:03  davidsi
// Initial version.
//
//
//
package org.snia.wbemcmd.mof;


//
// Lex exceptions
//
class MOFLexerException extends MOFParseException {
    static public final String LEX_ERR_BAD_TERM_STRING="Badly terminated string";
    static public final String LEX_ERR_FILE_NOT_LOAD="Could not load file";
    static public final String LEX_ERR_BAD_PATH="Could not find file";
    static public final String LEX_ERR_BAD_IO="IO Exception";
    static public final String LEX_ERR_EOF="EOF";
    static public final String LEX_ERR_BADTOKEN="NO SUCH TOKEN";
    String value;
    
    MOFLexerException(String errorString) {
	value=errorString;
    }
    
    String getValue() {
	return(value);
    }
    
    public String toString() {
	return(value);
    }
}
