//
// HTTPException.java
//
// The contents of this file are subject to the SNIA Public License Version 1.0
// (the "License"); you may not use this file except in compliance with the
// License. You may obtain a copy of the License at
//
//	http://www.snia.org/resources/openSource.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
// License for the specific language governing rights and limitations
// under the License.
//
// The Original Code is HTTPException.java
// 
// The Initial Developer of the Original Code is David Simons.
//
// Contributor(s):
//
//
//
// $Id: HTTPException.java,v 1.1 2003/07/17 18:32:55 kumpf Exp $
//
// $Log: HTTPException.java,v $
// Revision 1.1  2003/07/17 18:32:55  kumpf
// HP-BAPU: PEP-64 CIM Client and CIM Listener Java Interface
//
// Revision 1.1.1.1  2001/10/31 18:17:10  karl
// import of SNIA 0_7
//
// Revision 1.6  2000/08/16 05:59:59  shawn
// merge P_TOMCAT31 branch
//
// Revision 1.5.6.1  2000/08/10 00:03:36  shawn
// head merge
//
// Revision 1.5  2000/07/10 18:09:45  davidsi
// - Added HTTP_ERR_AUTHENTICATE.
//
// Revision 1.4  2000/05/11 10:11:23  davidsi
// - Fixed tabs.
//
// Revision 1.3  2000/05/06 17:20:02  davidsi
// - Brought in line with SUN WBEM APIs 2.2
//
// Revision 1.2  2000/02/13 15:10:04  davidsi
// - Added text to cover re-use of Solaris WBEM APIs.
//
// Revision 1.1.1.1  2000/02/06 16:41:02  davidsi
// Initial version.
//
//
//
package org.snia.wbemcmd.xml;

import java.lang.Exception;


public class HTTPException  extends Exception {
    public static final String HTTP_ERR_NEEDCONTENTLEN="HTTP_ERR_NEEDCONTENTLEN";
    public static final String HTTP_ERR_OPTIONSREQUESTED="HTTP_ERR_OPTIONSREQUESTED";
    public static final String HTTP_ERR_AUTHENTICATE="HTTP_ERR_AUTHENTICATE";
    public static final String HTTP_ERR_UNKNOWN="HTTP_ERR_UNKNOWN";
    public static final String HTTP_ERR_TRUNCATED="HTTP_ERR_TRUNCATED";     // input was truncated  
    public static final String HTTP_ERR_ILLEGALRESPONSE="HTTP_ERR_ILLEGALRESPONSE"; // input did not look like a response

    // Added Bapu  (08/20/02)
    public static final String HTTP_ERR_NOT_IMPLEMENTED="HTTP_ERR_NOT_IMPLEMENTED";
    public static final String HTTP_ERR_BAD_REQUEST="HTTP_ERR_BAD_REQUEST";

    String localId=null;
    int response=-1;		// see SC_XXX in HTTPWriter

    public HTTPException(String err, int iResponse) {
	localId=err;
	response=iResponse;
    }

    public HTTPException(String err) {
	localId=err;
    }
	
    public String getId() {
	return(localId);
    }
    
    public int getErrorCode() {
	return(response);
    }

    public String toString() {
	if (response>0)
	    return("HTTPException="+localId+", response="+response);
	else
	    return("HTTPException="+localId);
    }
}
