//
// Param.java
//
// The contents of this file are subject to the SNIA Public License Version 1.0
// (the "License"); you may not use this file except in compliance with the
// License. You may obtain a copy of the License at
//
//	http://www.snia.org/resources/openSource.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
// License for the specific language governing rights and limitations
// under the License.
//
// The Original Code is Param.java
// 
// The Initial Developer of the Original Code is David Simons.
//
// Contributor(s):
//
//
// This source uses the Solaris WBEM APIs version 2.2. 
// Synchronization will be maintained with the Solaris WBEM APIS,
// which are being standardized through the Java Community Process.
//
//
// $Id: Param.java,v 1.1 2003/07/17 18:32:55 kumpf Exp $
//
// $Log: Param.java,v $
// Revision 1.1  2003/07/17 18:32:55  kumpf
// HP-BAPU: PEP-64 CIM Client and CIM Listener Java Interface
//
// Revision 1.1.1.1  2001/10/31 18:17:21  karl
// import of SNIA 0_7
//
// Revision 1.6  2000/08/16 05:59:59  shawn
// merge P_TOMCAT31 branch
//
// Revision 1.5.8.1  2000/08/10 00:03:36  shawn
// head merge
//
// Revision 1.5  2000/05/11 10:11:23  davidsi
// - Fixed tabs.
//
// Revision 1.4  2000/05/06 17:20:02  davidsi
// - Brought in line with SUN WBEM APIs 2.2
//
// Revision 1.3  2000/04/09 14:32:37  davidsi
// - Removed misleading comment.
//
// Revision 1.2  2000/02/13 15:10:04  davidsi
// - Added text to cover re-use of Solaris WBEM APIs.
//
// Revision 1.1.1.1  2000/02/06 16:41:02  davidsi
// Initial version.
//
//
//
package org.snia.wbemcmd.xml;

//
// Param allows parameters to be built for transmission
// in an XML request
//
class Param {
    //
    // Use VALUESET when the value stored for the parameter
    // has already been embedded within the correct XML
    // tags
    static final int VALUENOTSET=0;
    static final int VALUESET=1;
    String argName;
    String argValue;
    int argMode;
	    
    Param(String argname,int mode,String value) {
	argName=argname;
	argValue=value;
	argMode=mode;
    }
	    
    Param(String argname,String value) {
	argName=argname;
	argValue=value;
	argMode=VALUENOTSET;
    }
	    
    Param(String argname,boolean value) {
	argName=argname;
	if (value)
	    argValue="TRUE";
	else
	    argValue="FALSE";
	argMode=VALUENOTSET;
    }	
	    
	    
    String getArgName() {
	return(argName);
    }
	    
    String getArgValue() {
	if (argValue!=null) {
	    if (argMode==VALUENOTSET)
		return("<VALUE>"+argValue+"</VALUE>");
	    return(argValue);
	}
	return("");
    }
}
