//
// XMLGetProperty.java
//
// The contents of this file are subject to the SNIA Public License Version 1.0
// (the "License"); you may not use this file except in compliance with the
// License. You may obtain a copy of the License at
//
//	http://www.snia.org/resources/openSource.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
// License for the specific language governing rights and limitations
// under the License.
//
// The Original Code is XMLGetProperty.java
// 
// The Initial Developer of the Original Code is David Simons.
//
// Contributor(s):
//
//
// This source uses the Solaris WBEM APIs version 2.2. 
// Synchronization will be maintained with the Solaris WBEM APIS,
// which are being standardized through the Java Community Process.
//
//
// $Id: XMLGetProperty.java,v 1.1 2003/07/17 18:32:55 kumpf Exp $
//
// $Log: XMLGetProperty.java,v $
// Revision 1.1  2003/07/17 18:32:55  kumpf
// HP-BAPU: PEP-64 CIM Client and CIM Listener Java Interface
//
// Revision 1.1.1.1  2001/10/31 18:17:45  karl
// import of SNIA 0_7
//
// Revision 1.5  2000/08/16 05:59:59  shawn
// merge P_TOMCAT31 branch
//
// Revision 1.4.8.1  2000/08/10 00:03:36  shawn
// head merge
//
// Revision 1.4  2000/05/11 10:11:24  davidsi
// - Fixed tabs.
//
// Revision 1.3  2000/05/06 17:20:03  davidsi
// - Brought in line with SUN WBEM APIs 2.2
//
// Revision 1.2  2000/02/13 15:10:06  davidsi
// - Added text to cover re-use of Solaris WBEM APIs.
//
// Revision 1.1.1.1  2000/02/06 16:41:02  davidsi
// Initial version.
//
//
//
package org.snia.wbemcmd.xml;

import java.util.Enumeration;
import java.util.Vector;
import java.net.MalformedURLException;
import org.snia.wbem.cim.CIMException;
import org.snia.wbem.cim.CIMObjectPath;
import org.snia.wbem.cim.CIMValue;
import org.snia.wbem.client.CIMOMHandle;



public class XMLGetProperty extends XMLClass {
    static int allowedElements[]={
	XMLNode.XML_ELEMENT_IPARAMVALUE
	};
    static String commandName="GetProperty";
    static Vector allowedAttrs;
    
	
    static {
	//
	// Set up valid parameter names
	//
	allowedAttrs=new Vector();
	allowedAttrs.addElement(new XMLAttribute(paramName,XMLP_PROPERTYNAME));

    }
    
    
    public void execute(HTTPWriter pw,XMLNode propNode,CIMObjectPath path,CIMOMHandle hdl)
	    throws CIMException, MalformedURLException {

	String propertyName=propNode.mustExtractParameterValue(XMLP_PROPERTYNAME);
	
	propNode=propNode.findElementAndParameter(XMLP_INSTANCENAME);
	if (propNode==null)
	    throw new CIMException(CIMException.CIM_ERR_INVALID_PARAMETER,
		"Could not find a <IPARAMVALUE> with an InstanceName argument");
    
	getInstanceName(propNode,path);
	
	CIMValue cv=hdl.getProperty(path,propertyName);
	//

	if (cv!=null)
	    pw.println(cv.toXml());
	return;
    }
    
    
    
    public static CIMValue getProperty(HTTPOutput output,
		   CIMObjectPath path,
		   String propName) throws CIMException {
	XMLNode result;
	Vector params=new Vector();

	output.setMethod(commandName);
	//
	// Always request qualifiers
	//
	params.addElement(new Param(XMLP_PROPERTYNAME,propName));


	result=intrinsicMethod(output,path,commandName,params,
			       instanceNameToKey(path,"InstanceName"));
		
	if (result==null) {
	    //
	    // Some kind of failure occurred but no exception has been
	    // thrown yet...so throw one!
	    //
	    throw new CIMException(CIMException.CIM_ERR_FAILED);
	}
	return(new CIMValue(result));
    }	
    
    
    
}
