//
// TestTimeout.java
//
// The contents of this file are subject to the SNIA Public License Version 1.0
// (the "License"); you may not use this file except in compliance with the
// License. You may obtain a copy of the License at
//
//	http://www.snia.org/resources/openSource.html
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
// License for the specific language governing rights and limitations
// under the License.
//
// The Original Code is TestTimeout.java
// 
// The Initial Developers of the Original Code are Bapu Patil 
//
//
// Revision 1.1  2002/05/15 09:36:59 bpatil
// Initial revision
//


package tests.ClientUnitTests;

import java.util.Enumeration;
import java.util.Vector;
import java.net.*;
import org.snia.wbem.client.CIMClient;
import org.snia.wbem.cim.*;



public class TestTimeout {

    public void example(String args[])
    {

	CIMNameSpace clientNameSpace;
	String hostName = "localhost";		// host for cimom
	String nameSpace = "root/cimv2";		// namespace
	CIMClient cc=null;
	int portNo=CIMNameSpace.DEFAULT_PORT;
	String hostURL;
        String isSSL = null;

        if (args.length>=3) {
            hostName=args[0];
            nameSpace=args[1];
            portNo=Integer.parseInt(args[2]);
        } else if (args.length!=0) {
            System.err.println("TestTimeout [hostname namespace portNo [ssl]]");
            System.exit(1);
        }

        if (args.length==4 && args[3].equalsIgnoreCase("ssl") )
        {
            isSSL=args[3];
        }
        if ( isSSL != null )
            hostURL="https://"+hostName+":"+portNo;
        else
            hostURL="http://"+hostName+":"+portNo;
	
	
	System.err.println("Connecting to "+hostName+
			    " for namespace "+nameSpace);
	try {

	    clientNameSpace = new CIMNameSpace(hostURL, nameSpace);  
	    cc = new CIMClient(clientNameSpace, "guest", "guest", CIMClient.XML);
            cc.setTimeout(200);

	} catch (CIMException e) {
	    System.err.println("Failed to access CIMOM: "+e);
	    System.exit(1);
	}
	
	System.err.println("Client created");


     //
     // should return an instance
     //   - Gets an instance for the specified object path
     //
     //
System.err.println("\n **********Enumerate Namespaces with Deep: root");
     try 
     {
        //CIMObjectPath pa1=new CIMObjectPath("root", (Vector)null);

        CIMObjectPath pa1=new CIMObjectPath("root", "root");
        Enumeration enum = cc.enumNameSpace(pa1, true);

        while (enum.hasMoreElements()) 
        {
	   String nsString = (String) enum.nextElement();
           System.out.println("NameSpace:"+ nsString);
        }
     }
     catch (CIMException ce) {
	 System.err.println("Failed to fetch namespaces:"+ce);
	 //ce.printStackTrace();
	 System.exit(1);
    }
System.err.println("\n **********Enumerate Namespaces with Deep: root/myNameSpace");
     try 
     {
        CIMObjectPath pa1=new CIMObjectPath("root/myNameSpace", (Vector)null);
        Enumeration enum = cc.enumNameSpace(pa1, true);

        while (enum.hasMoreElements()) 
        {
	   String nsString = (String) enum.nextElement();
           System.out.println("NameSpace:"+ nsString);
        }
     }
     catch (CIMException ce) {
	 System.err.println("Failed to fetch namespaces:"+ce);
	 System.exit(1);
    }
System.err.println("\n **********Enumerate Namespaces with Deep: null namespace");
     try 
     {
        CIMObjectPath pa1=new CIMObjectPath("", (Vector)null);
        Enumeration enum = cc.enumNameSpace(pa1, true);

        while (enum.hasMoreElements()) 
        {
	   String nsString = (String) enum.nextElement();
           System.out.println("NameSpace:"+ nsString);
        }
     }
     catch (CIMException ce) {
	 System.err.println("Failed to fetch namespaces:"+ce);
	 System.exit(1);
    }
System.err.println("\n **********Enumerate Namespaces with Deep: EMPTY");
     try 
     {
        CIMObjectPath pa1=new CIMObjectPath(" ", (Vector)null);
        Enumeration enum = cc.enumNameSpace(pa1, true);

        while (enum.hasMoreElements()) 
        {
	   String nsString = (String) enum.nextElement();
           System.out.println("NameSpace:"+ nsString);
        }
     }
     catch (CIMException ce) {
	 System.err.println("Failed to fetch namespaces:"+ce);
	 System.exit(1);
    }
     
     System.out.println("done:");
   }

   
   public TestTimeout() {
   }
   
    public static void main(String args[]){
	TestTimeout ea=new TestTimeout();
	ea.example(args);
    }
}
