##############################################################################
#
# Make rules for SNIA CIMOM
##############################################################################
# $Log: cimrules.mk,v $
# Revision 1.1  2003/07/17 18:32:55  kumpf
# HP-BAPU: PEP-64 CIM Client and CIM Listener Java Interface
#
# Revision 1.4  2001/03/08 08:45:55  mihajlov ( mihajlov@de.ibm.com )
# Removed CLASSPATH usage. New var EXTCLASSPATH used now.
#
# Revision 1.3  2001/01/12 20:17:18  mihajlov ( mihajlov@de.ibm.com )
# INSTALLBIN not needed presently.
#
# Revision 1.2  2001/01/12 10:59:19  mihajlov ( mihajlov@de.ibm.com )
# Add install and clean targets.
#
# Revision 1.3  2002/01/12 10:59:19  bpatil ( bapu_patil@hp.com )
# port to HP-UX
#
##############################################################################
#
# You must set the Java CLASSPATH to required jars. My classpath would include
#
#    /opt/java/xerces-1_0_4/xerces.jar  - XML Parser 1.0.4
#    /opt/java1.4/jre/lib/jsse.jar      - JSSE : Java Secure Socket
#    /opt/java1.4/jre/lib/rt.jar        - Java Runtime libraries
#    /src/snia_java14/                  - SNIA cimom source home
#    /src/snia_java14/sniacimom/obj/    - SNIA cimom Object home
#
##############################################################################

# Defaults - overridable
PACKAGE?=classes

OBJECTROOT=$(CIMCLIENT_ROOT)
MODROOT=$(OBJECTROOT)


#
# object Pathes
# export JAVACIM_OBJPATH=$(JAVACIM_OBJPATH)/cimclient
#
OBJBASE=$(CIMCLIENT_OBJPATH)/obj
OBJECTLIB=$(CIMCLIENT_OBJPATH)/lib

# object Pathes
INSTALLBASE=$(OBJBASE)
INSTALLLIB=$(OBJECTLIB)
INSTALLROOT=$(JAVACIM_OBJPATH)/install

SYSCLASSPATH=$(CLASSPATH)

RM=rm
JAR=jar
JAVAC=javac

JFLAGS=-g  -classpath  $(SYSCLASSPATH):$(OBJBASE):$(MODROOT)/cimclient:$(EXTCLASSPATH)

.SUFFIX: .java .class

$(OBJBASE)/$(PACKAGEDIR)/%.class: %.java
	$(JAVAC) $(JFLAGS) -d $(OBJBASE) $<

.PHONY: $(SUBDIRS)

all: $(OBJBASE) $(SUBDIRS) \
	$(patsubst %.java,$(OBJBASE)/$(PACKAGEDIR)/%.class,$(CLASSES))

$(SUBDIRS):
	$(MAKE) -C $@

$(OBJBASE):
	mkdir -p $@


package: all
	mkdir -p $(OBJECTLIB)
	$(JAR) cmf $(CIMCLIENT_ROOT)/MANIFEST.JCLIENT $(OBJECTLIB)/$(PACKAGE).jar -C $(OBJBASE)/ $(PACKAGEDIR)

install: package
	mkdir -p $(INSTALLLIB)
	cp $(OBJECTLIB)/$(PACKAGE).jar $(INSTALLLIB)

clean:
	$(RM) -f $(OBJECTLIB)/$(PACKAGE).jar
	$(RM) -rf $(OBJBASE)
